<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\NewLocalAtendimentoService;

class NewLocalAtendimentoController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $NewLocalAtendimentoService;
   
    public function __construct($crudService, $environment, NewLocalAtendimentoService $NewLocalAtendimentoService) {
        parent::__construct($crudService, $environment);
        $this->NewLocalAtendimentoService = $NewLocalAtendimentoService;
    }

    public function getControllerLocal(DTO\Request $request, DTO\Response $response) {
        $var = $this->NewLocalAtendimentoService->getServiceLocal();
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getControllerLocalParent(DTO\Request $request, DTO\Response $response) {
        $var = $this->NewLocalAtendimentoService->getServiceLocalParent();
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getControllerSector(DTO\Request $request, DTO\Response $response) {
        $var = $this->NewLocalAtendimentoService->getServiceSector();
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getControllerGroup(DTO\Request $request, DTO\Response $response) {
        $var = $this->NewLocalAtendimentoService->getServiceGroup();
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getControllerEmployee(DTO\Request $request, DTO\Response $response) {
        $var = $this->NewLocalAtendimentoService->getServiceEmployee();
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getControllerCheckList(DTO\Request $request, DTO\Response $response) {
        $var = $this->NewLocalAtendimentoService->getServiceCheckList();
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function insertControllerLocalAt(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $nmlocalcliente = $params['params']['NMLOCALCLIENTE'];
        $cdcliente = $params['params']['CDCLIENTE'];
        $nrtipolocalcli = $params['params']['NRTIPOLOCALCLI'];
        $nrlocalclientepai = $params['params']['NRLOCALCLIENTEPAI'];
        $nrchecklistpadr = $params['params']['NRCHECKLISTPADR'];
        $nrsetor = $params['params']['NRSETOR'];
        $dsiconelocal = $params['params']['DSICONELOCAL'];
        $dsqrcode = $params['params']['DSQRCODE'];
        $nrorg = $params['params']['NRORG'];
        $cdoperinclusao = $params['params']['CDOPERINCLUSAO'];
        $nrorginclusao = $params['params']['NRORGINCLUSAO'];
        $dtultatu = $params['params']['DTULTATU'];
        $cdoperultatu = $params['params']['CDOPERULTATU'];
        $nrorgultatu = $params['params']['NRORGULTATU'];
        $nrgrupolocal = $params['params']['NRGRUPOLOCAL'];
        $dscodigolocalcli = $params['params']['DSCODIGOLOCALCLI'];
        $dscoridlocal = $params['params']['DSCORIDLOCAL']['hexa'];
        
        
        $var = $this->NewLocalAtendimentoService->insertServiceLocalAt($nmlocalcliente, $cdcliente, $nrtipolocalcli, $nrlocalclientepai, $nrchecklistpadr, $nrsetor, $dsiconelocal, $dsqrcode, $nrorg, $cdoperinclusao, $nrorginclusao, $dtultatu, $cdoperultatu, $nrorgultatu, $nrgrupolocal, $dscodigolocalcli, $dscoridlocal);
        
        $dtsVal = new DataSet('options',array('error' => $var));
        $response->addDataSet($dtsVal);
    }
    
    // Função de inserir tarefa através da tela de criar local
    /*public function insertControllerTask(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameteres();
        
        $nrchecklistagend = $params['params']['NRCHECKLISTAGEND'];
        $nrfuncionario = $params['params']['NRFUNCIONARIO'];
        $dsobstarefaagend = $params['params']['DSOBSTAREFAAGEND'];
        $nrorg = $params['params']['nrorg'];
        $cdoperinclusao = $params['params']['CDOPERINCLUSAO'];
        $nrorginclusao = $params['params']['NRORGINCLUSAO'];
        $cdoperultatu = $params['params']['CDOPERULTATU'];
        $nrorgultatu = $params['params']['NRORGULTATU'];
        
        $var = $this->NewLocalAtendimentoService->insertServiceTask($nrchecklistagend, $nrfuncionario, $dsobstarefaagend, $nrorg, $cdoperinclusao, $nrorginclusao, $cdoperultatu, $nrorgultatu);
        
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }*/
    
    public function getControllerLocalAtToUpdate(DTO\Request $request, DTO\Response $response) {
        
        $params = $request->getParameters();
        
        $nrlocalcliente = $params['params']['NRLOCALCLIENTE'];

        $var = $this->NewLocalAtendimentoService->getServiceLocalAtToUpdate($nrlocalcliente);
        $dtsVal = new DataSet('options', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function updateControllerLocalAt(DTO\Request $request, DTO\Response $response) {
        
        $params = $request->getParameters();
        
        $nrlocalcliente = $params['params']['NRLOCALCLIENTE'];
        $nmlocalcliente = $params['params']['NMLOCALCLIENTE'];
        $nrtipolocalcli = $params['params']['NRTIPOLOCALCLI'];
        $nrlocalclientepai = $params['params']['NRLOCALCLIENTEPAI'];
        $nrsetor = $params['params']['NRSETOR'];
        $nrchecklistpadr = $params['params']['NRCHECKLISTPADR'];
        $dscodigolocalcli = $params['params']['DSCODIGOLOCALCLI'];
        $dscoridlocal = $params['params']['DSCORIDLOCAL'];
        
        $var = $this->NewLocalAtendimentoService->updateServiceLocalAt($nrlocalcliente, $nmlocalcliente, $nrtipolocalcli, $nrlocalclientepai, $nrsetor, $nrchecklistpadr, $dscodigolocalcli, $dscoridlocal);
        
        $dtsVal = new DataSet('options',array('error' => $var));
        $response->addDataSet($dtsVal);
    } 
    
    // Busca todos os locais
    public function getLocals(DTO\Request $request, DTO\Response $response) {
        $var = $this->NewLocalAtendimentoService->getLocals();
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
}
?>