<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class GLocaisFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getFactoryUnities($params) {
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE, DSCODIGOLOCALCLI, DSCORIDLOCAL
                  FROM FCM_LOCALCLI
                 WHERE NRLOCALCLIENTEPAI IS NULL".$params;
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryLocal($param) {
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE, DSCODIGOLOCALCLI
                 FROM FCM_LOCALCLI
                WHERE NRLOCALCLIENTEPAI = :NRLOCALCLIENTEPAI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($param);
        return $std->fetchAll();
    }
    
    public function getFactoryLocalType($params) {
        $sql = "SELECT NMTIPOLOCALCLI, NRTIPOLOCALCLI, IDTIPOLOCALCLI, CASE IDTIPOLOCALCLI 
                       WHEN '1' THEN 'Agrupamento Completo'
                       WHEN '2' THEN 'Agrupamento Simples'
                       WHEN '3' THEN 'Local de Atendimento'
                       ELSE NULL END AS TIPOLOCAL
                    FROM FCM_TIPOLOCALCLI ".$params." ORDER BY IDTIPOLOCALCLI ASC";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
}
?>