<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class GerenciamentoChkFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function listInspectionTask($param,$params) {
        $sql = "SELECT FCM_GERENCIAMENTOCHK.DTHORAAGEND, FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK, FCM_GERENCIAMENTOCHK.DTHRFINALAGEND, FCM_LOCALCLI.DSCORIDLOCAL FROM FCM_GERENCIAMENTOCHK
                    JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_GERENCIAMENTOCHK.NRLOCALCLIENTE
                WHERE TRUNC(FCM_GERENCIAMENTOCHK.DTHORAAGEND) BETWEEN TO_DATE( :startPeriod, 'YYYY-MM-DD') AND TO_DATE( :finishPeriod, 'YYYY-MM-DD')
                  AND FCM_GERENCIAMENTOCHK.NRFUNCIONARIO = :nr
                ".$params."
                ORDER BY DTHORAAGEND";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    } 

    public function transferVistoria($param) {
        $sql = "UPDATE FCM_GERENCIAMENTOCHK
                   SET NRFUNCIONARIO = ".$param['nr']."
                 WHERE NRGERENCIAMENTOCHK IN (".$param['list'].")";
        
        $std = $this->connection->prepare($sql);
        $std->execute();
    }

    public function dadosTransfer($param) {
        $sql = "UPDATE FCM_GERENCIAMENTOCHK
                   SET NRFUNCIONARIO = ".$param['nr']."
                 WHERE NRGERENCIAMENTOCHK IN (".$param['list'].")";
        
        $std = $this->connection->prepare($sql);
        $std->execute();
    }

    public function dadosVistoria($param) {
        $sql = "SELECT NRGERENCIAMENTOCHK, NRFUNCIONARIO, DTHORAAGEND
                  FROM FCM_GERENCIAMENTOCHK
                 WHERE NRGERENCIAMENTOCHK = ".$param;
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
}

?>