<?php
namespace FM\Service;

use FM\Factory\DashboardFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class DashboardService {
    
    protected $DashboardFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (DashboardFactory $DashboardFactory, Environment $Environment, NewCode $newCode) {
        $this->DashboardFactory  = $DashboardFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }
    
    // responsável por retornar os dados de limpeza finalizada do dashboard
    public function getDadosLimpezaFinalizada(){
        
        $selectDadosLimpezaFinalizada = $this->DashboardFactory->getDadosLimpezaFinalizada();
        
        return $selectDadosLimpezaFinalizada;
    }
    
    // responsável por retornar os dados de tarefa atrasada do dashboard
    public function getDadosTarefaAtrasada(){
        
        $selectDadosTarefaAtrasada = $this->DashboardFactory->getDadosTarefaAtrasada();
        
        return $selectDadosTarefaAtrasada;
    }
    
    // responsável por retornar os dados de tarefa finalizada do dashboard
    public function getDadosTarefaConcluida(){
        $selectTarefaConcluida = $this->DashboardFactory->getDadosTarefaConcluida();
        return $selectTarefaConcluida;
    }
    
    public function getDadosProgress(){
        $countTarefasConcluidas = $this->DashboardFactory->countTarefasConcluidas();
        $countTarefas  = $this->DashboardFactory->countTarefas();
        return[$countTarefasConcluidas,$countTarefas];
    }
    
    // requisição para retorno dos dados para o card (Ultimas Tarefas Realizadas) Dashboard Supervisor
    public function getDadosUltimasTarefas($param) {
        $parametroFiltro = '';
        if ($param['selectLocal'] != '' && $param['selectLocal'] != null && $param["selectData"] != null && $param["selectData"] != '') {
            $corte = substr($param["selectData"],0,5);
           $parametroFiltro = " WHERE ULTTAR.NRLOCALCLIENTE = ".$param['selectLocal']."AND TRUNC(ULTTAR.DTULTATU) = TO_DATE('".$corte."', 'DD/MM')";
        }
        else if($param['selectLocal'] == '' && $param["selectData"] != null && $param["selectData"] != ''){
            $corte = substr($param["selectData"],0,5);
            $parametroFiltro = " WHERE TRUNC(ULTTAR.DTULTATU) = TO_DATE('".$corte."', 'DD/MM')";
        } else if($param['selectLocal'] != '' && $param['selectLocal'] != null && $param["selectData"] == ''){
            $parametroFiltro = " WHERE ULTTAR.NRLOCALCLIENTE = ".$param['selectLocal'];
        }
        $selectDadosChecagemLimpeza = $this->DashboardFactory->getDadosUltimasTarefas($parametroFiltro);
        
        return $selectDadosChecagemLimpeza;
    }
    // requisição para retorno dos dados para o card (Resumo de Tarefas) Dashboard Supervisor(Tarefas Diárias)
    public function getDadosResumoTarefas($param) {
        $parametroFiltro = '';
        if ($param['selectLocal'] != '' && $param['selectLocal'] != null && $param["selectData"] != null && $param["selectData"] != '') {
           $corte = substr($param["selectData"],0,5);
           $parametroFiltro = " WHERE ULTTAR.NRLOCALCLIENTE = ".$param['selectLocal']."AND TRUNC(ULTTAR.DTULTATU) = TO_DATE('".$corte."', 'DD/MM')";
        }
        else if($param['selectLocal'] == '' && $param["selectData"] != null && $param["selectData"] != ''){
            $corte = substr($param["selectData"],0,5);
            $parametroFiltro = " WHERE TRUNC(ULTTAR.DTULTATU) = TO_DATE('".$corte."', 'DD/MM')";
        } else if($param['selectLocal'] != '' && $param['selectLocal'] != null && $param["selectData"] == ''){
            $parametroFiltro = " WHERE ULTTAR.NRLOCALCLIENTE = ".$param['selectLocal'];
        }
        
        $selectDadosChecagemLimpeza = $this->DashboardFactory->getDadosResumoTarefas($parametroFiltro);
        
        return $selectDadosChecagemLimpeza;
    }
    
    // requisição para retorno dos dados do grafico Tarefas Realizadas Dashboard Supervisor
    public function getDadosChartTarefas() {
        
        $selectDadosGraficos = $this->DashboardFactory->getDadosChartTarefas();
        
        return $selectDadosGraficos;
    }
    
    // requisição para retorno dos dados para o grafico Não Conformidades Dashboard Supervisor
    public function getDadosChartNaoConformidades() {
        
        $dadosChartNaoConformidades = $this->DashboardFactory->getDadosChartNaoConformidades();
        
        return $dadosChartNaoConformidades;
    }
    
    // requisição para retorno dos dados para grafico Progresso Diario Dashboard Supervisor(Tarefas Diárias)
    public function getDadosChartProgressoDiario() {
        
        $dadosChartProgressoDiario = $this->DashboardFactory->countTarefasConcluidasDia();
        
        return $dadosChartProgressoDiario;
    }
}