<?php
namespace FM\Service;

use FM\Factory\FCMAnaliseConformidadeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class FCMAnaliseConformidadeService {
    
  protected $FCMAnaliseConformidadeFactory;
  protected $Environment;
  protected $newCode;
  
  public function __construct (FCMAnaliseConformidadeFactory $FCMAnaliseConformidadeFactory, Environment $Environment, NewCode $newCode) {
    $this->FCMAnaliseConformidadeFactory  = $FCMAnaliseConformidadeFactory;
    $this->Environment                  = $Environment;
    $this->newCode                      = $newCode;
  }

  public function getCriterioNaoConformidade($param){
    $parametro = [];
    if($param["LocalType"] != null){
      $parametro[] = 'TLC.NRTIPOLOCALCLI = '.$param["LocalType"];
    }
    if($param["Local"] != null){
      $parametro[] = 'LC.NRLOCALCLIENTE = '.$param["Local"];
    }
    if($param["Sector"] != null){
      $parametro[] = 'LC.NRSETOR = '.$param["Sector"];
    }
    if($param["PeriodoDe"] != null || $param["PeriodoAte"] != null){
      if($param["PeriodoDe"] == null){
        $parametro[] = "TRUNC(GC.DTHORAAGEND) <= TO_DATE('".$param["PeriodoAte"]."', 'DD/MM/YYYY')";
      }elseif($param["PeriodoAte"] == null){
        $parametro[] = "TRUNC(GC.DTHORAAGEND) >= TO_DATE('".$param["PeriodoDe"]."', 'DD/MM/YYYY')";
      }else {
        $parametro[] = "TRUNC(GC.DTHORAAGEND) BETWEEN TO_DATE('".$param["PeriodoDe"]."', 'DD/MM/YYYY') AND TO_DATE('".$param["PeriodoAte"]."', 'DD/MM/YYYY')";
      }
    }
    
    $parametro = (count($parametro)) ? 'AND '.implode(' AND ',$parametro) : '';
    $operadores = $this->FCMAnaliseConformidadeFactory->getCriterioNaoConformidade($parametro);
    $dadosCriterio = [];
    
    forEach($operadores as $criterios) {
      if(!(isset($dadosCriterio[$criterios["NMLOCAL"]]))){
        $dadosCriterio[$criterios["NMLOCAL"]] = [];
      }
      if(!(in_array($criterios["NMCRITERIOTARGERCHK"],$dadosCriterio[$criterios["NMLOCAL"]]))){
        $dadosCriterio[$criterios["NMLOCAL"]][] = $criterios["NMCRITERIOTARGERCHK"];
      }
    }
    return $dadosCriterio;
  }

  public function getPrincipalNaoConformidade($param){

    $parametro = '';
    if($param["PeriodoDe"] != null || $param["PeriodoAte"] != null){
      if($param["PeriodoDe"] == null){
        $parametro = " AND TRUNC(TGC.DTHORATAREFAGERCHK) <= TO_DATE('".$param["PeriodoAte"]."', 'DD/MM/YYYY')";
      }elseif($param["PeriodoAte"] == null){
        $parametro = " AND TRUNC(TGC.DTHORATAREFAGERCHK) >= TO_DATE('".$param["PeriodoDe"]."', 'DD/MM/YYYY')";
      }else {
        $parametro = " AND TRUNC(TGC.DTHORATAREFAGERCHK) BETWEEN TO_DATE('".$param["PeriodoDe"]."', 'DD/MM/YYYY') AND TO_DATE('".$param["PeriodoAte"]."', 'DD/MM/YYYY')";
      }
    }
    $operadores = $this->FCMAnaliseConformidadeFactory->getPrincipalNaoConformidade($parametro);
    return $operadores;
  }
}